<?php
/**
 * Twitter Memory
 * http://www.prelude-prod.fr
 *
 * @author Jean-François RENAULD
 * @version 1.0
 * Cette oeuvre est mise à disposition selon les termes de la Licence Creative Commons Paternité - Partage à l'Identique 3.0 non transcrit.
 * http://creativecommons.org/licenses/by-sa/3.0/deed.fr
 *
 * Si vous utilisez ce script, n'hésitez pas à faire un lien vers le site de Prélude Prod : http://www.prelude-prod.fr
 *
*/

//---- gestion des tweets


/**
 * Renvoie la liste de tweets et le dernier ID
**/

function get_timeline($user = '', $max_id = FALSE, $first_id = FALSE, $count = 10, $utf8 = FALSE) {

	$URLTwitter = 'http://api.twitter.com/1/statuses/user_timeline.xml?screen_name='.$user.'&count='.$count;
	if($max_id !== FALSE) {
		$URLTwitter .= '&max_id='.$max_id;
	}

	if($first_id !== FALSE) {
		$URLTwitter .= '&since_id='.$first_id;
	}

	$dom = new DomDocument();
	$dom->load($URLTwitter);
	$racine = $dom->documentElement;
	$ListeProduits = $dom->getElementsByTagName('status');
	$nbr = $ListeProduits->length;

	$tab = array();
	$rs = 0;
	$lastId = FALSE;
	foreach($ListeProduits as $Node) {
		$created_at = DOMgetValue($Node, 'created_at');
		$text = DOMgetValue($Node, 'text');
		$id = DOMgetValue($Node, 'id');
		$gravatarTwitter = DOMgetValue($Node, 'profile_image_url');
		
		$lastId = $id;

		if($utf8 === TRUE) {
			$text = utf8_encode(stripslashes($text));
		}

		$tab[$rs]['id'] = $id;
		$tab[$rs]['created_at'] = $created_at;
		$tab[$rs]['text'] = $text;
		$tab[$rs]['profile_image_url'] = $gravatarTwitter;
		
		$text = mb_eregi_replace("([[:alnum:]]+)://([^[:space:]]*)([[:alnum:]#?/&=])", "<a href=\"\\1://\\2\\3\" title=\"Voir ce site\">\\1://\\2\\3</a>", utf8_decode($text));
		$text = mb_eregi_replace("(@([[:alnum:]]([-_.]?[[:alnum:]])*))", "<a href=\"http://twitter.com/\\2\" title=\"Voir ce tweet\">\\1</a>", $text);

		$tab[$rs]['text_format'] = $text;

		$date_format = date('Y-m-d H:i:s', strtotime($created_at));
		
		$tab[$rs]['date_format'] = $date_format;

		$rs++;
	}

	return array('tweets' => $tab, 'lastId' => $lastId);

}



function DOMgetValue($Node, $ref) {
	$valeur = $Node->getElementsByTagName($ref);
	if($valeur->length < 1) {
		return '';

	}else{
		return $valeur->item(0)->nodeValue;
	}
}